/* ViewDelegator.h     UIView subclasses to delegate GUI methods
 *
 * Copyright (c) 2011 Psellos   http://psellos.com
 * Licensed under the MIT license:
 *     http://www.opensource.org/licenses/mit-license.php
 */

/* Protocol for the delegate.  (Just one method for this example.)
 */
@protocol ViewDelegate
@optional
- (void) viewLayoutSubviews: (UIView *) view;
@end

/* Interfaces for the delegators.
 */

@interface ViewDelegator : UIView
{
    NSObject<ViewDelegate> *delegate;
}
@property(nonatomic, assign) IBOutlet NSObject<ViewDelegate> *delegate;
@end

/* A subclass of ViewDelegator for OpenGL ES graphics.
 */

@interface ViewDelegatorGL : ViewDelegator
{
}
@end
