(* $Id: glTex.mli,v 1.7 2007/04/13 02:48:43 garrigue Exp $ *)

open Gl

type env_param = [
    `mode of [`modulate|`decal|`blend|`replace] 
  | `color of rgba]
val env : env_param -> unit

type format =
    [`alpha|`rgb|`rgba|`luminance|`luminance_alpha|`bgra]
type compressed_format =
    [`palette4_rgb8|`palette4_rgba8|`palette4_r5_g6_b5|`palette4_rgba4
    |`palette4_rgb5_a1|`palette8_rgb8|`palette8_rgba8|`palette8_r5_g6_b5
    |`palette8_rgba4|`palette8_rg5b_a1|`rgb_pvrtc_4bppv1|`rgb_pvrtc_2bppv1
    |`rgba_pvrtc_4bppv1|`rgba_pvrtc_2bppv1]
val image2d :
  ?level:int -> ?internal:([< format] as 'a) -> ?border:bool ->
      ('a, [< kind]) GlPix.t -> unit
val sub_image2d :
  ?level:int -> int -> int -> ([< format], [< kind]) GlPix.t -> unit
val compressed_image2d :
  ?level:int -> ?border:bool -> [< compressed_format] -> int -> int ->
      [`ubyte] Raw.t -> unit

type filter =
    [`nearest|`linear|`nearest_mipmap_nearest|`linear_mipmap_nearest
    |`nearest_mipmap_linear|`linear_mipmap_linear]
type wrap = [`repeat|`clamp_to_edge]
type parameter = [
    `min_filter of filter
  | `mag_filter of [`nearest|`linear]
  | `wrap_s of wrap
  | `wrap_t of wrap
  | `generate_mipmap of bool
] 
val parameter : target:[`texture_2d] -> parameter -> unit

type texture_id
val texture0 : texture_id (* Default texture id *)
val gen_texture : unit -> texture_id
val gen_textures : len:int -> texture_id array
val bind_texture : target:[`texture_2d] -> texture_id -> unit
val delete_texture : texture_id -> unit
val delete_textures : texture_id array -> unit
